#ifndef EXCEPTIONS_HPP
#define EXCEPTIONS_HPP

#include "symbol.hpp"
#include <string>
#include <vector>

struct parser_exception {};

struct no_function_match_exception {
    std::string              prototype;
    std::vector<std::string> available;
};

struct no_binary_operator_match_exception {
    symbol s1;
    symbol s2;
    std::string op;

    no_binary_operator_match_exception(const symbol& s1, const std::string& op, const symbol& s2) :
        s1(s1.clone()), s2(s2.clone()), op(op) {}
};

struct no_unary_operator_match_exception {
    symbol s;
    std::string op;

    no_unary_operator_match_exception(const std::string& op, const symbol& s) :
        s(s.clone()), op(op) {}
};

#endif
